unit BitsForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Image1: TImage;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Label2: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Panel5: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Panel6: TPanel;
    Label8: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function ShowBits(B : Byte): string;
var
  i: Integer;
  bt: Byte;
  s: string;
begin
  bt := $01;
  s := '';
  for i := 1 to 8 do begin
    if (b And bt) > 0 then
       S := '1' + s
    else
      s := '0' + s;
     {$R-}
      bt := bt shl 1;
     {$R+}
    end;
  ShowBits := s;
end;

function IsBitOn (Value: Byte; Bit: Byte): Boolean;
begin
  Result := (Value and (1 shl Bit)) <> 0;
end;

function TurnBitOn (Value: Byte; Bit: Byte): Integer;
begin
  Result := Value or (1 shl Bit);
end;

function TurnBitOff (Value: Byte; Bit: Byte): Integer;
begin
  Result := Value and not (1 shl Bit);
end;

function StripFromFront(S: string; Len: Integer): string;
Var
 Count : integer;
begin
 Count:=Length(S)-Len;
 Move(S[Len+1],S[1],Count);
 SetLength(S,Count);
 Result:=S;
end;


procedure TForm1.Edit1Change(Sender: TObject);
var
  I: Integer;
  CheckBox: TCheckBox;
begin
  for I := 1 to 16 do
  begin
    Checkbox := FindComponent (
      'Checkbox' + IntToStr (I)) as TCheckbox;
    CheckBox.Checked :=
      IsBitOn (UpDown1.Position, CheckBox.Tag);
  end;
end;

procedure TForm1.CheckBoxClick(Sender: TObject);
var
  Val,TmpBits: byte;
  S : string;
begin
  Val := UpDown1.Position;
  with Sender as TCheckBox do
    if Checked then
      Val := TurnBitOn (Val, Tag)
    else
      Val := TurnBitOff (Val, Tag);
  UpDown1.Position := Val;

  S:=ShowBits(Val);
  Label8.Caption:=S;

  TmpBits:=Val;
  TmpBits:=TmpBits and 15; // mask 00001111 extract lo bits
  S:=ShowBits(TmpBits);
  Label2.Caption:=StripFromFront(S,4);

  TmpBits:=Val;
  TmpBits:=TmpBits SHR 4; //extract hi bits
  S:=ShowBits(TmpBits);
  Label3.Caption:=StripFromFront(S,4);

end;

end.
